#include "to_bin.hpp"

#include<iostream>
#include<cfloat>
#include<cmath>
#include <cstring>
using namespace std;

int main() {

  cout << 1.0 << endl;
  to_bin(1.0);
  to_bin(static_cast<float>(1.0));
  cout << pow(2,
                pow(2,0)+pow(2,1)+pow(2,2)+pow(2,3)+pow(2,4)
                +pow(2,5)+pow(2,6) // biased exponent (added pow(2,7)-1)
                -(pow(2,7)-1) // correction to unbiased exponent
          ) 
          *1 // mantissa
          << endl;

  cout << 2.1 << endl;
  to_bin(2.1);
  to_bin(static_cast<float>(2.1));
  cout << pow(2,
              pow(2,7) // biased exponent
              -(pow(2,7)-1) // correction to unbiased exponent
             ) 
             *(1+pow(2,-5)+pow(2,-6)+pow(2,-9)+pow(2,-10) 
             +pow(2,-13)+pow(2,-14)+pow(2,-17)+pow(2,-18)
             +pow(2,-21)+pow(2,-22)) // mantissa
       << endl;
  cout << std::endl;

  cout << "Special cases:" << std::endl << std::endl;

  cout << 0 << endl;
  to_bin(0.0);
  to_bin(static_cast<float>(0.0)); // special representation of zero
  cout << pow(2,0 // biased exponent
              -(pow(2,7)-1)// correction to unbiased exponent
             ) 
              *1 // mantissa 
       << endl; // !=0
  cout << std::endl;

  cout << 1./0. << endl;
  to_bin(1./0.);
  to_bin(static_cast<float>(1./0.));
  cout << pow(2, 
		 pow(2,0)+pow(2,1)+pow(2,2)+pow(2,3)+pow(2,4)
                +pow(2,5)+pow(2,6) + pow(2,7) // biased exponent (added pow(2,7)-1)
                -(pow(2,7)-1) // correction to unbiased exponent
             ) 
              *1 // mantissa 
       << endl; // ! inf
  cout << std::endl;

  cout << 0./0. << endl;
  to_bin(0./0.);
  to_bin(static_cast<float>(0./0.));
  cout << -pow(2, 
		 pow(2,0)+pow(2,1)+pow(2,2)+pow(2,3)+pow(2,4)
                +pow(2,5)+pow(2,6) + pow(2,7) // biased exponent (added pow(2,7)-1)
                -(pow(2,7)-1) // correction to unbiased exponent
             ) 
              *(1+pow(2,-1)) // mantissa 
       << endl; // ! nan

  return 0;
}

/*

1
00111111 10000000 00000000 00000000
1

2.1
01000000 00000110 01100110 01100110 
2.1

0
00000000 00000000 00000000 00000000 
5.87747e-39 (note special representation of zero)

*/











